#define TRUE                    1
#define FALSE                   0
#define ENTER 13
#define ESC 27
#define Base_IO_Add   0x234
#define INT4          0x0c    //COM1 IRQ
#define INT10         0x72

#include <stdio.h>
#include <dos.h>
#include <process.h>
#include <direct.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <malloc.h>
#include <conio.h>
#include "vga.h"
#include "image.h"

void Dump(int *cx, int *cy);
void moment(void);
int mousest;
int step=10;

void main(void)
{
  mousest=InitialMouse();
  setfont("crt.lsf");

  if(GraphInit()==-1)
  {
    printf("\n\n    *************Incorrect  VGA ***************\n\n");
    exit(0);
   }
 
  getch();
  SetText();

moment();
}


//********Start of moment*************************/

void moment()
{
  int i, j, x=100, y=100,value;
  long int gray[257],temp;
  long float cd, c0, c1, z0, z1, pd, p0, p1;
  long float m1, m2, m3;

  
  Loadimage("jj3.tif");
  m1=0;
  m2=0;
  m3=0;
  for(i=0;i<256;i++)  gray[i]=0;

  for(i=0;  i<600; i++)
  {
    for(j=0; j<480; j++)
     {
       temp=GetPix(i,j)/8;        //divid by 8 prevent temp overflow
       gray[temp]=gray[temp]+1;

       m1=(temp)/(600.*480.)+m1;
       m2=(temp*temp)/(600.*480.)+m2;
       m3=(temp*temp*temp)/(600.*480.)+m3;
      } 
    // printf("  ");
   }
  /* m1=m1/(4*12);
   m2=m2/(4*12);
   m3=m3/(4*12); */
   cd= m2-m1*m1;
   c0= (1./cd)*(-m2*m2+m1*m3);
   c1= (1./cd)*(-m3+m1*m2);
   z0=0.5*(-c1- sqrt(c1*c1-4*c0) );
   z1=0.5*(-c1+ sqrt(c1*c1-4*c0) );
   pd=z1-z0;
   p0=(z1-m1)/pd;

   temp=0;
   for (i=0;i<256;i++)
    {
      temp=temp+gray[i];
      if ( temp > p0*600*480)
       {
         value=i*8;                  //because GetPix has been by 8 upper
         break;
        }
     }   
   
  for(i=0;  i<640; i++)
  {
    for(j=0; j<480; j++)
    {
     temp=GetPix(i,j);
     //if(temp <(z0+z1)*8*0.5) PutPix(0,i,j);
     //else                    PutPix(temp-100,i,j);

     if(temp <value) PutPix(0,i,j);
     //else if( (temp-60)<=0)  PutPix(0,i,j); 
     else                    PutPix(temp-100,i,j);


     }
   }
  Dump(&x, &y);
  //getch();
  
  }



//***************End of moment***************/

void Dump(int *cx,int *cy)
{
        int i,j;
        int oldx,oldy,dx=0,dy=0;
        int     newx,newy;
        char coor[30];
        char temp[10];
        char mbuf[20000];
/* select the start point */
        oldx=(*cx);
        oldy=(*cy);
        BCURSOR(oldx,oldy);
        itoa(oldx,coor,10);
        strcat(coor,",");
        itoa(oldy,temp,10);
        strcat(coor,temp);
        strcat(coor,",");
        itoa(GetPix(oldx,oldy),temp,10);
        strcat(coor,temp);
        GetImg(oldx+12,oldy,oldx+130,oldy+20,mbuf);
 gText(255  , 1      ,vc.cheight, coor  , oldx+12, oldy   ,0  ) ;

        for(;;){
        switch(hercmouse(&dx,&dy)) {
                case 1:
                case 2:
                BCURSOR(oldx,oldy);
                PutImg(oldx+12,oldy,mbuf);
                return;
                default:
         (*cx)=( (oldx+ dx>=vc.MINX) &&( oldx+ dx<vc.MAXX))?oldx+ dx : oldx ;
         (*cy)=( (oldy+ dy>=vc.MINY) && (oldy+ dy<vc.MAXY))?oldy+ dy : oldy ;

                BCURSOR(oldx,oldy);
        PutImg(oldx+12,oldy,mbuf);
                BCURSOR((*cx),(*cy));
        itoa((*cx),coor,10);
        strcat(coor,",");
        itoa((*cy),temp,10);
        strcat(coor,temp);
        strcat(coor,",");
        itoa(GetPix((*cx),(*cy)),temp,10);
        strcat(coor,temp);
        GetImg((*cx)+12,(*cy),(*cx)+130,(*cy)+20,mbuf);
gText(255  , 1      ,vc.cheight, coor  , (*cx)+12, (*cy)   ,0  ) ;
                oldx=(*cx);oldy=(*cy);
                break;
                }
                }
}
